This is to resurrect NetWare as a supported target. Test results have been
posted to gcc-testresults (with this and the mentioned below auxiliary
patches applied).

Correct functionality implies the previously posted patches to correct
#pragma pack(), to support the preference of linking against a shared libgcc,
and the section separator to indicate section fragments to be merged by the
linker.

top level:
2004-07-07 Jan Beulich <jbeulich@novell.com>

	* configure.in: Remove target-libstdc++-v3 from noconfigdirs. Add
	target-libmudflap to noconfigdirs.
	Consolidate *-*-netware targets (of which reallyonly i?86 exists) into
	a single entry.
	* configure: Regenerate.

gcc:
2004-07-07 Jan Beulich <jbeulich@novell.com>

	* config.gcc: Resurrect NetWare as a target. Handle special case of
	Novell linker to be used (specified through --with-ld=) and threading
	model of either Posix (default) or NKS.
	* config/i386/i386.c (ix86_return_pops_args): Conditionalize popping
	of incoming hidden argument on KEEP_AGGREGATE_RETURN_POINTER.
	* config/i386/netware-crt0.c: New.
	* config/i386/netware.c: New.
	* config/i386/netware.h: Resurrect.
	* config/i386/t-netware: New.
	* config/netware-libgcc.def: New.
	* config/netware-libgcc.exp: New.
	* config/netware.h: Resurrect.
	* config/nwld.h: New.
	* config/t-nwld: New.
	* cp/g++spec.c (MATH_LIBRARY_PROFILE): Default to MATH_LIBRARY rather
	than "-lm".
	(LIBSTDCXX_PROFILE): Default to LIBSTDCXX rather than "-lstdc++".
	* fixinc/inclhack.def: Suppress exception_structure and math_exception
	for NetWare headers.
	* fixinc/fixincl.x: Regenerate.
	* gthr-nks.h: New.

gcc/testsuite:
2004-07-07 Jan Beulich <jbeulich@novell.com>

	* g++.dg/abi/bitfield5.C: Use -mno-ms-bitfields.
	* g++.old-deja/g++.jason/thunk2.C: xfail for NetWare.
	* g++.old-deja/g++.law/profile1.C: xfail for NetWare.
	* g++.old-deja/g++.other/store-expr1.C: xfail for NetWare.
	* gcc.c-torture/compile/20001109-1.c: xfail for NetWare.
	* gcc.c-torture/compile/20001109-2.c: xfail for NetWare.
	* gcc.c-torture/execute/multi-ix.c: Use __builtin_bzero rather than
	then non-portable bzero.
	* gcc.dg/20010912-1.c: xfail for NetWare.
	* gcc.dg/20020426-2.c: xfail for NetWare.
	* gcc.dg/20021014-1.c: xfail for NetWare.
	* gcc.dg/20021018-1.c: xfail for NetWare.
	* gcc.dg/20030213-1.c: xfail for NetWare.
	* gcc.dg/20030225-1.c: xfail for NetWare.
	* gcc.dg/20030708-1.c: xfail for NetWare.
	* gcc.dg/builtins-config.h: Also exclude NetWare.
	* gcc.dg/format/format.h: Define restrict only if not already defined.
	* gcc.dg/nest.c: xfail for NetWare.
	* gcc.dg/special/gcsec-1.c: Don't pass -static for NetWare.
	* lib/target-supports.exp (check_visibility_available): Exclude
	NetWare.

libstdc++-v3:
2004-07-07 Jan Beulich <jbeulich@novell.com>

	* crossconfig.m4: Add NetWare as a target.
	* configure: Regenerate.

--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/configure.in	2004-07-02 15:12:35.000000000 +0200
+++ 2004-07-05.10.09/configure.in	2004-07-06 14:05:44.617686256 +0200
@@ -412,7 +412,7 @@
     esac
     ;;
   *-*-netware)
-    noconfigdirs="$noconfigdirs target-libstdc++-v3 target-newlib target-libiberty target-libgloss ${libgcj}"
+    noconfigdirs="$noconfigdirs target-newlib target-libiberty target-libgloss ${libgcj} target-libmudflap"
     ;;
   *-*-rtems*)
     noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
@@ -1399,10 +1399,7 @@
 extra_ranlibflags_for_target=
 target_makefile_frag=/dev/null
 case "${target}" in
-  i[[3456789]]86-*-netware*)
-    target_makefile_frag="config/mt-netware"
-    ;;
-  powerpc-*-netware*)
+  *-*-netware)
     target_makefile_frag="config/mt-netware"
     ;;
   *-*-linux*)
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config.gcc	2004-07-02 15:13:19.000000000 +0200
+++ 2004-07-05.10.09/gcc/config.gcc	2004-07-06 09:08:56.628912048 +0200
@@ -948,6 +948,24 @@
 	fi
 	use_fixproto=yes
 	;;
+i[3456x]86-*-netware*)
+	tm_file="${tm_file} i386/unix.h i386/att.h elfos.h svr4.h tm-dwarf2.h netware.h i386/netware.h"
+ 	tmake_file=i386/t-netware
+	extra_objs=netware.o
+	case /${with_ld} in
+	*/nwld)
+		tm_file="${tm_file} nwld.h"
+	 	tmake_file="${tmake_file} t-nwld"
+		extra_parts="crt0.o libgcc.def libc.def libcpre.def posixpre.def"
+		;;
+	esac
+	case x${enable_threads} in
+	x | xyes | xposix) thread_file='posix';;
+	xnks) thread_file='nks';;
+	xno) ;;
+	*) echo 'Unknown thread configuration for NetWare' >&2; exit 1;;
+	esac
+	;;
 i[34567]86-*-nto-qnx*)
 	tm_file="${tm_file} i386/att.h dbxelf.h tm-dwarf2.h elfos.h svr4.h i386/unix.h i386/nto.h"
 	tmake_file=i386/t-nto
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/i386/i386.c	2004-07-02 15:20:42.000000000 +0200
+++ 2004-07-05.10.09/gcc/config/i386/i386.c	2004-07-06 09:04:06.240057864 +0200
@@ -1849,6 +1849,7 @@
       return size;
   }
 
+#ifndef KEEP_AGGREGATE_RETURN_POINTER
   /* Lose any fake structure return argument if it is passed on the stack.  */
   if (aggregate_value_p (TREE_TYPE (funtype), fundecl)
       && !TARGET_64BIT)
@@ -1858,6 +1859,7 @@
       if (!nregs)
 	return GET_MODE_SIZE (Pmode);
     }
+#endif
 
   return 0;
 }
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/i386/netware-crt0.c	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/i386/netware-crt0.c	2004-05-12 08:27:29.000000000 +0200
@@ -0,0 +1,74 @@
+/* Startup routines for NetWare.
+   Contributed by Jan Beulich (jbeulich@novell.com)
+   Copyright (C) 2004 Free Software Foundation, Inc.
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include <stddef.h>
+#include <stdint.h>
+
+void __main(void);
+int __init_environment(void*);
+int __deinit_environment(void*);
+
+#define SECTION_DECL(name, decl) decl __attribute__((__section__(name)))
+
+SECTION_DECL(".ctors",   void(*const __CTOR_LIST__)(void)) = (void(*)(void))(intptr_t)-1;
+SECTION_DECL(".ctors$_", void(*const __CTOR_END__)(void)) = NULL;
+
+SECTION_DECL(".dtors",   void(*const __DTOR_LIST__)(void)) = (void(*)(void))(intptr_t)-1;
+SECTION_DECL(".dtors$_", void(*const __DTOR_END__)(void)) = NULL;
+
+/* currently, up to 7 of the elements are used; see gcc/unwind-dw2-fde.h */
+struct object {void*_[8];};
+/* No need to use the __[de]register_frame_info_bases functions since
+   for us the bases are NULL always anyway. */
+void __register_frame_info (const void *, struct object *) __attribute__((__weak__));
+void *__deregister_frame_info (const void *) __attribute__((__weak__));
+SECTION_DECL(".eh_frame", /*const*/ uint32_t __EH_FRAME_BEGIN__[]) = { };
+SECTION_DECL(".eh_frame$_", /*const*/ uint32_t __EH_FRAME_END__[]) = {0};
+
+/* This function is required for all platforms that do not support the
+   .init/.fini mechanism of invoking constructors. Still, it's a dummy
+   for us since we use a different startup/shutdown approach. */
+void __main(void) {}
+
+int __init_environment(void*unused __attribute__((__unused__))) {
+	void(*const*pctor)(void);
+	static struct object object;
+
+	if(__register_frame_info)
+		__register_frame_info(__EH_FRAME_BEGIN__, &object);
+	for(pctor = &__CTOR_END__ - 1; pctor > &__CTOR_LIST__; --pctor)
+		if(*pctor != NULL)
+			(*pctor)();
+	return 0;
+}
+
+int __deinit_environment(void*unused __attribute__((__unused__))) {
+	// This should be static to prevent calling the same destructor
+	// twice (just in case where we get here multiple times).
+	static void(*const*pdtor)(void) = &__DTOR_LIST__ + 1;
+
+	while(pdtor < &__DTOR_END__)
+		if(*pdtor++ != NULL)
+			pdtor[-1]();
+	if(__deregister_frame_info)
+		__deregister_frame_info(__EH_FRAME_BEGIN__);
+	return 0;
+}
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/i386/netware.c	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/i386/netware.c	2004-07-06 12:33:10.711008408 +0200
@@ -0,0 +1,208 @@
+/* Subroutines for insn-output.c for NetWare.
+   Contributed by Jan Beulich (jbeulich@novell.com)
+   Copyright (C) 2004 Free Software Foundation, Inc.
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "config.h"
+#include "system.h"
+#include "coretypes.h"
+#include "tm.h"
+#include "rtl.h"
+#include "regs.h"
+#include "hard-reg-set.h"
+#include "output.h"
+#include "tree.h"
+#include "flags.h"
+#include "tm_p.h"
+#include "toplev.h"
+#include "ggc.h"
+
+
+/* Return string which is the former assembler name modified with an 
+   underscore prefix and a suffix consisting of an atsign (@) followed
+   by the number of bytes of arguments */
+
+static const char *
+gen_stdcall_decoration (tree decl)
+{
+  unsigned total = 0;
+  /* ??? This probably should use XSTR (XEXP (DECL_RTL (decl), 0), 0) instead
+     of DECL_ASSEMBLER_NAME.  */
+  const char *asmname = IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (decl));
+  char *newsym;
+
+  if (TYPE_ARG_TYPES (TREE_TYPE (decl)))
+    if (TREE_VALUE (tree_last (TYPE_ARG_TYPES (TREE_TYPE (decl))))
+        == void_type_node)
+      {
+	tree formal_type = TYPE_ARG_TYPES (TREE_TYPE (decl));
+
+	/* Quit if we hit an incomplete type.  Error is reported
+	   by convert_arguments in c-typeck.c or cp/typeck.c.  */
+	while (TREE_VALUE (formal_type) != void_type_node
+	       && COMPLETE_TYPE_P (TREE_VALUE (formal_type)))	
+	  {
+	    unsigned parm_size
+	      = TREE_INT_CST_LOW (TYPE_SIZE (TREE_VALUE (formal_type)));
+	    /* Must round up to include padding.  This is done the same
+	       way as in store_one_arg.  */
+	    parm_size = ((parm_size + PARM_BOUNDARY - 1)
+			 / PARM_BOUNDARY * PARM_BOUNDARY);
+	    total += parm_size;
+	    formal_type = TREE_CHAIN (formal_type);
+	  }
+      }
+
+  newsym = xmalloc (1 + strlen (asmname) + 1 + 10 + 1);
+  sprintf (newsym, "_%s@%u", asmname, total/BITS_PER_UNIT);
+  return IDENTIFIER_POINTER (get_identifier (newsym));
+}
+
+/* Return string which is the former assembler name modified with a
+   prefix consisting of FASTCALL_PREFIX and a suffix consisting of an
+   atsign (@) followed by the number of bytes of arguments.  */
+
+static const char *
+gen_fastcall_decoration (tree decl)
+{
+  unsigned total = 0;
+  const char *asmname = IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (decl));
+  char *newsym;
+
+  if (TYPE_ARG_TYPES (TREE_TYPE (decl)))
+    if (TREE_VALUE (tree_last (TYPE_ARG_TYPES (TREE_TYPE (decl))))
+        == void_type_node)
+      {
+	tree formal_type = TYPE_ARG_TYPES (TREE_TYPE (decl));
+
+	/* Quit if we hit an incomplete type.  Error is reported
+	   by convert_arguments in c-typeck.c or cp/typeck.c.  */
+	while (TREE_VALUE (formal_type) != void_type_node
+	       && COMPLETE_TYPE_P (TREE_VALUE (formal_type)))	
+	  {
+	    int parm_size
+	      = TREE_INT_CST_LOW (TYPE_SIZE (TREE_VALUE (formal_type)));
+	    /* Must round up to include padding.  This is done the same
+	       way as in store_one_arg.  */
+	    parm_size = ((parm_size + PARM_BOUNDARY - 1)
+			 / PARM_BOUNDARY * PARM_BOUNDARY);
+	    total += parm_size;
+	    formal_type = TREE_CHAIN (formal_type);
+	  }
+      }
+
+  newsym = xmalloc (1 + strlen (asmname) + 1 + 10 + 1);
+  sprintf (newsym, "%c%s@%d", FASTCALL_PREFIX, asmname, total/BITS_PER_UNIT);
+  return IDENTIFIER_POINTER (get_identifier (newsym));
+}
+
+/* Return string which is the former assembler name modified with an 
+   _n@ prefix where n represents the number of arguments passed in
+   registers */
+
+static const char *
+gen_regparm_prefix (tree decl, unsigned nregs)
+{
+  unsigned total = 0;
+  /* ??? This probably should use XSTR (XEXP (DECL_RTL (decl), 0), 0) instead
+     of DECL_ASSEMBLER_NAME.  */
+  const char *asmname = IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (decl));
+  char *newsym;
+
+  if (TYPE_ARG_TYPES (TREE_TYPE (decl)))
+    if (TREE_VALUE (tree_last (TYPE_ARG_TYPES (TREE_TYPE (decl))))
+        == void_type_node)
+      {
+	tree formal_type = TYPE_ARG_TYPES (TREE_TYPE (decl));
+
+	/* Quit if we hit an incomplete type.  Error is reported
+	   by convert_arguments in c-typeck.c or cp/typeck.c.  */
+	while (TREE_VALUE (formal_type) != void_type_node
+	       && COMPLETE_TYPE_P (TREE_VALUE (formal_type)))	
+	  {
+	    unsigned parm_size
+	      = TREE_INT_CST_LOW (TYPE_SIZE (TREE_VALUE (formal_type)));
+	    /* Must round up to include padding.  This is done the same
+	       way as in store_one_arg.  */
+	    parm_size = ((parm_size + PARM_BOUNDARY - 1)
+			 / PARM_BOUNDARY * PARM_BOUNDARY);
+	    total += parm_size;
+	    formal_type = TREE_CHAIN (formal_type);
+	  }
+      }
+
+  if (nregs > total / BITS_PER_WORD)
+    nregs = total / BITS_PER_WORD;
+  if (nregs > 9) abort();
+  newsym = xmalloc (2 + strlen (asmname) + 1 + 1);
+  sprintf (newsym, "_%u@%s", nregs, asmname);
+  return IDENTIFIER_POINTER (get_identifier (newsym));
+}
+
+void
+i386_nlm_encode_section_info (tree decl, rtx rtl, int first)
+{
+  default_encode_section_info (decl, rtl, first);
+
+  if (first
+      && TREE_CODE (decl) == FUNCTION_DECL
+      && *IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (decl)) != '*')
+    {
+      tree type_attributes = TYPE_ATTRIBUTES (TREE_TYPE (decl));
+      rtx rtlname = XEXP (rtl, 0);
+      if (GET_CODE (rtlname) == MEM)
+	rtlname = XEXP (rtlname, 0);
+      if (lookup_attribute ("stdcall", type_attributes))
+	XSTR (rtlname, 0) = gen_stdcall_decoration (decl);
+      else if (lookup_attribute ("fastcall", type_attributes))
+	XSTR (rtlname, 0) = gen_fastcall_decoration (decl);
+      else
+	{
+	  tree attr = lookup_attribute ("regparm", type_attributes);
+
+	  if (attr)
+	    XSTR (rtlname, 0) =
+	      gen_regparm_prefix (decl,
+		      TREE_INT_CST_LOW (TREE_VALUE (TREE_VALUE (attr))));
+	}
+    }
+}
+
+/* Strip the stdcall/fastcall/regparm pre-/suffix.  */
+
+const char *
+i386_nlm_strip_name_encoding (const char *str)
+{
+  const char *name = default_strip_name_encoding (str);
+
+  if (*str != '*' && (*name == '_' || *name == '@'))
+    {
+      const char *p = strchr(name + 1, '@');
+
+      if (p)
+	{
+	  ++name;
+	  if (ISDIGIT (p[1]))
+	    name = ggc_alloc_string (name, p - name);
+	  else if (!ISDIGIT (*name) || ++name != p)
+	    abort();
+	}
+    }
+  return name;
+}
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/i386/netware.h	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/i386/netware.h	2004-05-28 11:40:48.000000000 +0200
@@ -0,0 +1,123 @@
+/* Core target definitions for GCC for Intel 80386 running Netware 4.
+   and using dwarf for the debugging format.
+   Copyright (C) 1993, 1994, 2004 Free Software Foundation, Inc.
+
+   Written by David V. Henkel-Wallace (gumby@cygnus.com)
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#undef  TARGET_VERSION
+#define TARGET_VERSION fprintf (stderr, " (x86 NetWare)");
+
+#define TARGET_OS_CPP_BUILTINS()					\
+  do									\
+    {									\
+	builtin_define ("IAPX386");					\
+	builtin_define ("_M_IX86=300");					\
+	builtin_define ("__netware__");					\
+	builtin_assert ("system=netware");				\
+	builtin_define ("__ELF__");					\
+	builtin_define ("__cdecl=__attribute__((__cdecl__))");		\
+	builtin_define ("__stdcall=__attribute__((__stdcall__))");	\
+	builtin_define ("__fastcall=__attribute__((__fastcall__))");	\
+	if (!flag_iso)							\
+	  {								\
+	    builtin_define ("_cdecl=__attribute__((__cdecl__))");	\
+	    builtin_define ("_stdcall=__attribute__((__stdcall__))");	\
+	    builtin_define ("_fastcall=__attribute__((__fastcall__))");	\
+	  }								\
+    }									\
+  while (0)
+
+#undef TARGET_CPU_DEFAULT
+#define TARGET_CPU_DEFAULT TARGET_CPU_DEFAULT_pentium4
+
+/* By default, target has a 80387, uses IEEE compatible arithmetic,
+   returns float values in the 387, and uses MSVC bit field layout. */
+#undef TARGET_SUBTARGET_DEFAULT
+#define TARGET_SUBTARGET_DEFAULT (MASK_80387 | MASK_IEEE_FP | \
+	MASK_FLOAT_RETURNS | MASK_MS_BITFIELD_LAYOUT)
+
+#undef MATH_LIBRARY
+#define MATH_LIBRARY ""
+
+/* Align doubles and long-longs in structures on qword boundaries.  */
+#undef BIGGEST_FIELD_ALIGNMENT
+#define BIGGEST_FIELD_ALIGNMENT 64
+
+#undef DEFAULT_PCC_STRUCT_RETURN
+#define DEFAULT_PCC_STRUCT_RETURN 0
+
+/* Implicit arguments pointing to aggregate return values are to be removed by the caller */
+#define KEEP_AGGREGATE_RETURN_POINTER
+
+#undef DBX_REGISTER_NUMBER
+#define DBX_REGISTER_NUMBER(n) (svr4_dbx_register_map[n])
+
+/* Enable parsing of #pragma pack(push,<n>) and #pragma pack(pop).  */
+#define HANDLE_PRAGMA_PACK_PUSH_POP
+
+/* Default structure packing is 1-byte. */
+#define DEFAULT_PACK_STRUCT 1
+
+#undef WCHAR_TYPE
+#define WCHAR_TYPE "short unsigned int"
+
+#undef WCHAR_TYPE_SIZE
+#define WCHAR_TYPE_SIZE 16
+
+/* A C statement (sans semicolon) to output to the stdio stream
+   FILE the assembler definition of uninitialized global DECL named
+   NAME whose size is SIZE bytes and alignment is ALIGN bytes.
+   Try to use asm_output_aligned_bss to implement this macro.  */
+
+#define ASM_OUTPUT_ALIGNED_BSS(FILE, DECL, NAME, SIZE, ALIGN) \
+  asm_output_aligned_bss (FILE, DECL, NAME, SIZE, ALIGN)
+
+/* Handle special EH pointer encodings.  Absolute, pc-relative, and
+   indirect are handled automatically.  */
+#define ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX(FILE, ENCODING, SIZE, ADDR, DONE) \
+  do {									\
+    if ((SIZE) == 4 && ((ENCODING) & 0x70) == DW_EH_PE_datarel)		\
+      {									\
+        fputs (ASM_LONG, FILE);			\
+        assemble_name (FILE, XSTR (ADDR, 0));				\
+	fputs (((ENCODING) & DW_EH_PE_indirect ? "@GOT" : "@GOTOFF"), FILE); \
+        goto DONE;							\
+      }									\
+  } while (0)
+
+/* there is no TLS support in NLMs/on NetWare */
+#undef HAVE_AS_TLS
+
+/* Define this macro if references to a symbol must be treated
+   differently depending on something about the variable or
+   function named by the symbol (such as what section it is in).
+
+   On i386 running NetWare, modify the assembler name with an undercore (_)
+   prefix and a suffix consisting of an atsign (@) followed by a string of
+   digits that represents the number of bytes of arguments passed to the
+   function, if it has the attribute STDCALL. Alternatively, if it has the 
+   REGPARM attribute, prefix it with an underscore (_), a digit representing
+   the number of registers used, and an atsign (@). */
+void i386_nlm_encode_section_info (tree, rtx, int);
+const char *i386_nlm_strip_name_encoding (const char *);
+#undef TARGET_ENCODE_SECTION_INFO
+#define TARGET_ENCODE_SECTION_INFO  i386_nlm_encode_section_info
+#undef  TARGET_STRIP_NAME_ENCODING
+#define TARGET_STRIP_NAME_ENCODING  i386_nlm_strip_name_encoding
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/i386/t-netware	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/i386/t-netware	2004-06-02 10:06:21.000000000 +0200
@@ -0,0 +1,10 @@
+TARGET_LIBGCC2_CFLAGS = -mpreferred-stack-boundary=2
+
+netware.o: $(srcdir)/config/i386/netware.c $(RTL_H) $(TREE_H) $(CONFIG_H) $(TM_P_H)
+	$(CC) -c $(ALL_CFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) $(srcdir)/config/i386/netware.c
+
+# We don't need some of GCC's own include files.
+USER_H = $(srcdir)/ginclude/stdarg.h \
+         $(srcdir)/ginclude/varargs.h \
+         $(srcdir)/unwind.h \
+    $(EXTRA_HEADERS) $(LANG_EXTRA_HEADERS)
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/netware-libgcc.def	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/netware-libgcc.def	2004-04-06 15:37:14.000000000 +0200
@@ -0,0 +1,2 @@
+description "gcc runtime and intrinsics support"
+copyright "(C) 2004 Novell, Inc."
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/netware-libgcc.exp	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/netware-libgcc.exp	2004-05-10 14:26:31.000000000 +0200
@@ -0,0 +1,62 @@
+# libgcc_s.nlm exports
+	(libgcc2),
+	__absvdi2,
+	__absvsi2,
+	__addvdi3,
+	__addvsi3,
+#	__ashldi3,
+#	__ashrdi3,
+	__clzdi2,
+	__clzsi2,
+	__ctzdi2,
+	__ctzsi2,
+	__deregister_frame,
+	__deregister_frame_info,
+	__deregister_frame_info_bases,
+#	__divdi3,
+	__ffsdi2,
+	__ffssi2,
+	__fixunsdfdi,
+	__fixunssfdi,
+#	__fixunstfdi,
+	__fixunsxfdi,
+	__gcc_bcmp,
+	__gcc_personality_v0,
+#	__lshrdi3,
+#	__moddi3,
+#	__muldi3,
+	__mulvdi3,
+	__mulvsi3,
+	__negvdi2,
+	__negvsi2,
+	__paritydi2,
+	__paritysi2,
+	__popcountdi2,
+	__popcountsi2,
+	__register_frame,
+	__register_frame_info,
+	__register_frame_info_bases,
+	__register_frame_info_table,
+	__register_frame_info_table_bases,
+	__register_frame_table,
+	__subvdi3,
+	__subvsi3,
+#	__umoddi3,
+#	__udivdi3,
+	_Unwind_Backtrace,
+	_Unwind_DeleteException,
+	_Unwind_FindEnclosingFunction,
+	_Unwind_Find_FDE,
+	_Unwind_ForcedUnwind,
+	_Unwind_GetCFA,
+	_Unwind_GetDataRelBase,
+	_Unwind_GetGR,
+	_Unwind_GetIP,
+	_Unwind_GetLanguageSpecificData,
+	_Unwind_GetRegionStart,
+	_Unwind_GetTextRelBase,
+	_Unwind_RaiseException,
+	_Unwind_Resume,
+	_Unwind_Resume_or_Rethrow,
+	_Unwind_SetGR,
+	_Unwind_SetIP
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/netware.h	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/netware.h	2004-06-02 10:01:54.000000000 +0200
@@ -0,0 +1,64 @@
+/* netware.h -- operating system specific defines to be used when 
+   targeting GCC for some generic NetWare system.
+   Copyright (C) 1993, 1994, 2000, 2001, 2002 Free Software Foundation, Inc.
+
+   Written by David V. Henkel-Wallace (gumby@cygnus.com)
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#define TARGET_VERSION fprintf (stderr, " (NetWare)");
+
+#undef  CPP_SPEC
+#define CPP_SPEC "%{posix:-D_POSIX_SOURCE} %{pthread:-D_REENTRANT}"
+
+#undef	LIB_SPEC
+#define LIB_SPEC ""
+
+/* Kinda useless, but what the hell */
+#undef	LINK_SPEC
+#define LINK_SPEC "%{h*} %{V} %{v:%{!V:-V}} \
+		   %{b} %{Wl,*:%*} \
+		   %{Qy:} %{!Qn:-Qy}"
+
+#undef	STARTFILE_SPEC
+#define STARTFILE_SPEC ""
+
+#undef	ENDFILE_SPEC
+#define ENDFILE_SPEC ""
+
+#undef	RELATIVE_PREFIX_NOT_LINKDIR
+#undef	LIBGCC_SPEC
+
+/* Support const sections and the ctors and dtors sections for g++.  */
+
+#undef	HAS_INIT_SECTION
+#undef	INIT_SECTION_ASM_OP
+
+#undef	READONLY_DATA_SECTION_ASM_OP
+#define READONLY_DATA_SECTION_ASM_OP    ".section\t.rodata"
+
+/* Define the names of g++' constructors and destructors sections.  */
+#undef  CTORS_SECTION_ASM_OP
+#define CTORS_SECTION_ASM_OP	"\t.section\t.ctors"MERGE_SECTION_SEPARATOR",\"a\",\"progbits\""
+#undef  DTORS_SECTION_ASM_OP
+#define DTORS_SECTION_ASM_OP	"\t.section\t.dtors"MERGE_SECTION_SEPARATOR",\"a\",\"progbits\""
+
+#define CTOR_LISTS_DEFINED_EXTERNALLY
+
+#undef  EH_FRAME_SECTION_NAME
+#define EH_FRAME_SECTION_NAME ".eh_frame"MERGE_SECTION_SEPARATOR
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/nwld.h	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/nwld.h	2004-06-07 16:36:37.000000000 +0200
@@ -0,0 +1,51 @@
+/* nwld.h -- defines to be used when targeting GCC for some generic NetWare
+   system while using the Novell linker.
+   Copyright (C) 2004 Free Software Foundation, Inc.
+
+   Written by Jan Beulich (jbeulich@novell.com)
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#undef	LIB_SPEC
+#define LIB_SPEC "-lc --def-file libc.def%s"
+
+#undef	LIBGCC_SPEC
+#define LIBGCC_SPEC "-lgcc %{!static-libgcc:--def-file libgcc.def%s}"
+
+#undef  LINKER_NAME
+#define LINKER_NAME "nwld"
+
+#undef  LINK_SPEC
+#define LINK_SPEC "--format nlm %{static:%{!nostdlib:%{!nodefaultlib:%eStatic linking is not supported.\n}}}"
+
+#undef  LINK_GCC_C_SEQUENCE_SPEC
+#define LINK_GCC_C_SEQUENCE_SPEC "%L %G"
+
+/* In order to permit the linker to derive the output filename from the first
+   input file, put the common startup code as the last object. */
+#undef	STARTFILE_SPEC
+#define STARTFILE_SPEC ""
+
+#undef	ENDFILE_SPEC
+#define ENDFILE_SPEC "crt0%O%s ../imports/%{!posix:libc}%{posix:posix}pre.gcc%O%s" \
+	" --def-file %{!posix:libc}%{posix:posix}pre.def%s"
+
+#define PREFER_SHARED_LIBGCC
+
+#undef  MERGE_SECTION_SEPARATOR
+#define MERGE_SECTION_SEPARATOR "$"
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/config/t-nwld	1970-01-01 01:00:00.000000000 +0100
+++ 2004-07-05.10.09/gcc/config/t-nwld	2004-06-02 10:06:58.000000000 +0200
@@ -0,0 +1,48 @@
+CRTSTUFF_T_CFLAGS = -mpreferred-stack-boundary=2
+CRT0STUFF_T_CFLAGS = -mpreferred-stack-boundary=2
+# this is a slight misuse (it's not an assembler file)
+CRT0_S = $(srcdir)/config/i386/netware-crt0.c
+MCRT0_S = $(srcdir)/config/i386/netware-crt0.c
+
+libgcc.def: $(srcdir)/config/t-nwld
+	echo "module libgcc_s" >$@
+
+libc.def: $(srcdir)/config/t-nwld
+	echo "module libc" >$@
+
+libcpre.def: $(srcdir)/config/t-nwld
+	echo "start _LibCPrelude" >$@
+	echo "exit _LibCPostlude" >>$@
+	echo "check _LibCCheckUnload" >>$@
+
+posixpre.def: $(srcdir)/config/t-nwld
+	echo "start POSIX_Start" >$@
+	echo "exit POSIX_Stop" >>$@
+	echo "check POSIX_CheckUnload" >>$@
+
+# Build a shared libgcc library for NetWare.
+
+SHLIB_EXT = .nlm
+SHLIB_SONAME = @shlib_so_name@.nlm
+SHLIB_NAME = @shlib_dir@@shlib_so_name@.nlm
+SHLIB_SLIBDIR_QUAL = @shlib_slibdir_qual@
+SHLIB_DEF = $(srcdir)/config/netware-libgcc.def
+SHLIB_MAP = $(srcdir)/config/netware-libgcc.exp
+
+SHLIB_LINK = set -e; \
+	echo "version $(gcc_version)" | sed "s!\.!,!g" >@shlib_so_name@.def; \
+	touch libgcc/build; \
+	echo "build $$$$(($$$$(<libgcc/build)+0))" >>@shlib_so_name@.def; \
+	echo "export @$(SHLIB_MAP)" >>@shlib_so_name@.def; \
+	cat $(SHLIB_DEF) >>@shlib_so_name@.def; \
+	$(GCC_FOR_TARGET) $(LIBGCC2_CFLAGS) -o $(SHLIB_NAME) -static-libgcc -v \
+		-Wl,--Map,--map-info,full,--strip-all,--def-file,@shlib_so_name@.def; \
+	rm -f @shlib_so_name@.imp; $(LN_S) $(SHLIB_MAP) @shlib_so_name@.imp; \
+	echo $$$$(($$$$(<libgcc/build)+1)) > libgcc/build
+
+# $(slibdir) double quoted to protect it from expansion while building
+# libgcc.mk.  We want this delayed until actual install time.
+SHLIB_INSTALL = \
+	$$(SHELL) $(srcdir)/mkinstalldirs $$(slibdir)$(SHLIB_SLIBDIR_QUAL); \
+	$$(INSTALL_DATA) $(SHLIB_NAME) $$(slibdir)$(SHLIB_SLIBDIR_QUAL)/$(SHLIB_SONAME); \
+	$$(INSTALL_DATA) @shlib_so_name@.imp $$(DESTDIR)$$(libsubdir)/
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/cp/g++spec.c	2004-07-02 15:23:52.000000000 +0200
+++ 2004-07-05.10.09/gcc/cp/g++spec.c	2004-07-06 09:04:25.364150560 +0200
@@ -36,14 +36,14 @@
 #define MATH_LIBRARY "-lm"
 #endif
 #ifndef MATH_LIBRARY_PROFILE
-#define MATH_LIBRARY_PROFILE "-lm"
+#define MATH_LIBRARY_PROFILE MATH_LIBRARY
 #endif
 
 #ifndef LIBSTDCXX
 #define LIBSTDCXX "-lstdc++"
 #endif
 #ifndef LIBSTDCXX_PROFILE
-#define LIBSTDCXX_PROFILE "-lstdc++"
+#define LIBSTDCXX_PROFILE LIBSTDCXX
 #endif
 
 void
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/fixinc/fixincl.x	2004-05-03 17:19:16.000000000 +0200
+++ 2004-07-05.10.09/gcc/fixinc/fixincl.x	2004-07-06 09:04:25.414142960 +0200
@@ -1812,7 +1812,7 @@
  *  content bypass pattern - skip fix if pattern found
  */
 tSCC zException_StructureBypass0[] =
-       "matherr.*(struct exception|__MATH_EXCEPTION)";
+       "matherr.*(struct exception|__MATH_EXCEPTION|[ \\t]*__FP_EXCEPTION[ \\t]*\\*[ \\t]*)";
 
 #define    EXCEPTION_STRUCTURE_TEST_CT  2
 static tTestDesc aException_StructureTests[] = {
@@ -3421,7 +3421,7 @@
  *  content bypass pattern - skip fix if pattern found
  */
 tSCC zMath_ExceptionBypass0[] =
-       "We have a problem when using C\\+\\+";
+       "We have a problem when using C\\+\\+|for C\\+\\+, _[a-z0-9A-Z_]+_exception; for C, exception";
 
 #define    MATH_EXCEPTION_TEST_CT  2
 static tTestDesc aMath_ExceptionTests[] = {
--- /home/jbeulich/src/gcc/mainline/2004-07-05.10.09/gcc/fixinc/inclhack.def	2004-05-03 17:19:16.000000000 +0200
+++ 2004-07-05.10.09/gcc/fixinc/inclhack.def	2004-07-06 09:04:25.435139768 +0200
@@ -1054,7 +1054,7 @@
     files     = math.h;
 
     /*  If matherr has a prototype already, the header needs no fix.  */
-    bypass    = 'matherr.*(struct exception|__MATH_EXCEPTION)';
+    bypass    = 'matherr.*(struct exception|__MATH_EXCEPTION|[ \t]*__FP_EXCEPTION[ \t]*\*[ \t]*)';
     select    = matherr;
 
     c_fix     = wrap;
@@ -1904,7 +1904,7 @@
      * exception either.  So currently we bypass only for glibc, based on a
      * comment in the fixed glibc header.  Ick.
      */
-    bypass    = 'We have a problem when using C\+\+';
+    bypass    = 'We have a problem when using C\+\+|for C\+\+, _[a-z0-9A-Z_]+_exception; for C, exception';
     c_fix     = wrap;
 
     c_fix_arg = "#ifdef __cplusplus\n"
